create table LOGOPERACAOENTRADASAIDA (
Numoperacao Int IDENTITY NOT NULL,
Numord Int NOT NULL,
DataHora  Datetime NOT NULL,
SitNota Char(1) NOT NULL,
TipoNF Char(01),
FilialNF Char(02),
FilialAdicional Char(02),
FilialAtualizada  Char(02),
Usuario Int,
EstNota Char(01))
GO
alter table LOGOPERACAOENTRADASAIDA ADD CONSTRAINT PK_LOGOPERACAOENTRADASAIDA PRIMARY KEY (NUMOPERACAO)
GO

create index idx_1 on (numord)
go

insert into item (rescopo, criadopor, atualizadopor, codigo, criadoem, atualizadoem , observacao, nome, cid, oid, excluido) values (7           ,1,1,'','01/01/01','01/01/01','Utiliza Filial Agrupadora (S/N)','Utiliza Filial Agrupadora',18,28706,0)
go
insert into categoria (rsuper, nomeinterno, oid) values (2376 ,'UTILIZA_FILIAL_AGRUPADORA',28706)
go
insert into dadoadicional ( RCLASSECONCRETA,RAPLICATIVO,RDOMINIO,RLISTA,RTIPO,RITEM,RESTRICAO,VISIVEL,MASCARA,PADRAO,MAXIMO,MINIMO,VALOR,OID) values (7,1884 ,15812,7,28706,10128,0.0,0.0,'','',0.0,0.0,'',28705)
go
insert into aditivo (RITEM,RDEFINICAO,SVALOR,OID) values (1    ,28705,'',28707)
go
 
insert into dadoadicional ( RCLASSECONCRETA,RAPLICATIVO,RDOMINIO,RLISTA,RTIPO,RITEM,RESTRICAO,VISIVEL,MASCARA,PADRAO,MAXIMO,MINIMO,VALOR,OID) values (7,7    ,7,7672,1130,2124,0.0,0.0,'','',1.0,0.0,'Filial Agrupadora',28704)
go


/*
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
STORED PROCEDURE PARA ATUALIZACAO DO ESTOQUE
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
*/
-- nao usar como nome o inicio SP pois perde performance
drop procedure Stored_Gravar_Estoque
CREATE PROCEDURE Stored_Gravar_Estoque
				@tnNumord  Bigint,
				@tcFilial  Char(2),
                @tcEstNota Char(1), -- 1: QUANT / 2: ESTESTRATE / 3: QUANT E ESTESTRATE
                @tcTipoNF  Char(1), -- E -> notas de entrada e S -> notas de saidas
                @tcSitNota Char(1)
				
AS
 
BEGIN 
 
  SET NOCOUNT ON -- informar ao sql server para nao exibir mensagens de alerta
 
  -- declarando variaveis a serem usadas junto ao cursor 
  DECLARE @Quant money, @CodPro char(5) 
 
  -- declarando um cursor para navegarmos nos registros e gerarmos a atualizacao
  IF @tcTipoNF = 'E'
       DECLARE TmpItNF SCROLL CURSOR  FOR 
       SELECT CodPro, Quant FROM ItNfEntcad WHERE numord=@tnNumord 
    
	ELSE
       DECLARE TmpItNF SCROLL CURSOR  FOR 
       SELECT CodPro, Quant FROM ItNfSaicad WHERE numord=@tnNumord 

 
  OPEN TmpItNF
 
  -- vai para o primeiro registro do cursor
  FETCH FIRST FROM TmpItNF INTO @CodPro, @Quant
  
   WHILE @@FETCH_STATUS = 0 
   BEGIN
      
      IF (SELECT COUNT(*) FROM Itemfilest WHERE codpro=@Codpro AND filial=@tcFilial) = 0
	      INSERT ITEMFILEST (Filial,codpro) values (@tcFilial, @CodPro)
      
      
 	  -- Soma na quantidade
		
      IF (@tcTipoNF ='E' AND @tcSitNota='3') OR (@tcTipoNF ='S' AND  @tcSitNota='4') OR
	     (@tcSitNota='5') OR (@tcSitNota='8')
	     BEGIN
	        IF (@tcEstNota = '1' OR @tcEstNota = '3')
		       UPDATE itemfilest SET quant = quant + @Quant WHERE codpro=@Codpro and filial=@tcFilial
	
  		    IF (@tcEstNota = '2' OR @tcEstNota = '3')
		       UPDATE itemfilest SET estestrate = estestrate + @Quant WHERE codpro=@Codpro AND filial=@tcFilial
		   
		    IF (@tcSitNota= '8')
		       UPDATE itemfilest SET qtdereserv = qtdereserv + @Quant WHERE codpro=@Codpro AND filial=@tcFilial
	  	 END
	  	 
	  -- Subtrai na Quantidade
      IF (@tcTipoNF ='S' AND @tcSitNota='3') OR (@tcTipoNF ='E' AND  @tcSitNota='4') OR
	     (@tcSitNota='6') or (@tcSitNota='7')
	     BEGIN
	        IF (@tcEstNota = '1' OR @tcEstNota = '3')
		       UPDATE itemfilest SET quant = quant - @Quant WHERE codpro=@Codpro AND filial=@tcFilial
	
  		    IF (@tcEstNota = '2' OR @tcEstNota = '3')
		       UPDATE itemfilest SET estestrate = estestrate - @Quant WHERE codpro=@Codpro AND filial=@tcFilial
		       
		    IF @tcSitNota = '7'   
		       UPDATE itemfilest SET qtdeReserv = qtdeReserv - @Quant WHERE codpro=@Codpro AND filial=@tcFilial
	  	 END    	 
 
	-- passar para proximo registro
 	FETCH NEXT FROM TmpItNF INTO @CodPro, @Quant
   END
 
   CLOSE TmpItNF      -- fechando cursor
   DEALLOCATE TmpItNF -- desalocando de memoria o cursor
   
   -- Gravar a situao de confirmao indicando que a operao foi realizada
   INSERT logOperacaoEntradaSaida (numord,datahora,sitnota, tiponf,filialnf,filialadicional,filialatualizada,Usuario,estnota) 
   VALUES (@tnNumord,GetDate(),'C',@tcTipoNF, '','',@tcFilial,1,@tcEstNota)
   
 
   SET NOCOUNT OFF -- ativando comentarios do banco
END

--------------------------------------------------------------------------------

/*
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
TRIGGER QUE DEVE DISPARA STORED PROCEDURE = STORED_GRAVAR_ESTOQUE
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
*/
drop Trigger logOperacaoEntradaSaida_I
CREATE TRIGGER logOperacaoEntradaSaida_I ON logOperacaoEntradaSaida FOR INSERT AS
BEGIN
  -- decarando campos que serao transmitidos para stored procedure
  DECLARE @nNumord Bigint, @cFilial Char(2), @cEstNota Char(1),  @cTipoNF Char(1), @cSitNota Char(1) 
  -- Situaes da Nota:
  -- '3' = Aguardando Devoluo  
  -- '4' = Aguardando Cancelamento
  -- '5' = Aguardando atualizao estoque - Entrada  
  -- '6' = Aguardando atualizao estoque - Sada
  -- '7' = Aguardando atualizao estoque e reservado - Sada
  -- '8' = Aguardando Cancelamento - Pedido
  IF (SELECT Count(*) FROM inserted WHERE SitNota IN ('3','4','5','6','7','8') AND FilialAtualizada <> '' AND EstNota <> '0') > 0
     BEGIN
       SELECT @nNumord = NumOrd, @cFilial = FilialAtualizada, @cEstNota = EstNota, @cTipoNF = TipoNF, @cSitNota = SitNota FROM inserted
       EXEC Stored_Gravar_Estoque @nNumord, @cFilial, @cEstNota, @cTipoNF, @cSitNota
     END
     RETURN
END
GO
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 



